# kaz-vagrant

[Kaz](https://kaz.bzh/) est un CHATONS du Morbihan. Nous proposons ici un moyen de le répliquer dans une VM. Il y a des éléments de configuration à définir avant d'initialiser ce simulateur.

Le principe est de faire fonctionner un simulateur de notre CHATONS dans une VirtualBox pour mettre au point nos différents services.

Nous utilisons :
  * Vagrant pour automatiser la création de la Machine Virtuelle
  * VirtualBox pour simuler notre serveur
  * Docker pour chaque service de notre serveur

## Pré-requis

Vous avez besoin de [vagrant](https://www.vagrantup.com/), [VirtualBox](https://www.virtualbox.org/) et éventuellement git.

## Installation

* Télécharger le dépôt kaz-vagrant ou utilisez la commande git :
```bash
git clone https://git.kaz.bzh/KAZ/kaz-vagrant.git # pour essayer
git clone git+ssh://git@git.kaz.bzh:2202/KAZ/kaz-vagrant.git # pour contribuer
cd kaz-vagrant/
```
* Personalisez votre simulateur avec la commande (au besoin ajustez la mémoire et les cpus utilisés dans Vagrantfile) :
```bash
vagrant plugin install vagrant-disksize
./init.sh  # vous pouvez laisser les choix par défaut
```
* Pour créer tout l'univers Kaz il faut se placer dans le répertoire et lancer la commande :
```bash
vagrant up
```

Cette étape peut-être (très) longue. Il faudra éventuellement répondre "docker0" à la question "Which interface should the network bridge to?"


## Mise au point

Il est possible d'interrompre la création à la coquille vide (juste la VM sans les services KAZ) pour des question de mise au point avec la commande :
```bash
NOKAZ="true" vagrant up
```

Dans ce cas, il faudra ensuite lancer dans la VM :
```bash
/kaz/bin/install.sh
```

Pour détruire la VM et recommencer :
```bash
vagrant destroy
```


## Utilisation

Les utilisateurs créés sont
  * debian/debian
  * root/root.

Si vous avec laissé la création des dockers, il faut bien attendre la fermeture automatique de la fenêtre et l'apparition de l'écran de connexion (on vous a dit que c'était long).

Lors du démarrage de la VM, il faut lancer les conteneurs dans la VM :
```bash
/kaz/bin/container.sh start
```

Vous pouvez alors démarrer le client de messagerie clawsmail dans lequel 4 comptes ont été paramétrés (contact1@kaz.local, contact2@kaz.local, contact3@kaz.local, contact4@kaz.local)

Il y a un aperçu de l'état des services avec l'url https://kaz.local/status/allServices.html

![status](/doc/images/allServices.jpg)

Les erreurs 502 correspondent à des fonctions en cours de développement. Les message "Can't open this page" correspond au fait que le services refuse pour des raison de sécurité de de fonctionner embarqué dans une page.


Vous pouvez également démarrer firefox avec les URL suivantes:
  * https://www.kaz.local
  * https://tableur.kaz.local
  * https://pad.kaz.local
  * https://depot.kaz.local
  * https://agora.kaz.local/login (compte contact1@kaz.local créé, mot de passe toto)
  * https://cloud.kaz.local/login (compte contact1@kaz.local créé, mot de passe totototototototo1234 )
  * https://sondage.kaz.local

Il vous faudra accepter les alertes de sécurité pour certificat absent (web et messagerie)

## Installation avancée

L'installation avancée, notamment pour utiliser d'autres miroirs ou des caches APT, est décrite dans le fichier [DETAILS.md](DETAILS.md).
